; Parameter: Yl,Yh- Daten input
; temp3= CMD 



		.equ	PWM_CNT_M16					= $7A
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX		
PWM_CNT_WR:						
		rcall	TWI_START_CONDITION
		cpi		temp, MT_Start_Condition
		Brne	PWM_CNT_WR_ERR

; bertrgt die SLA+W
		ldi		temp, PWM_CNT_M16
		rcall	TWI_SLA_W						// Sendet SLA+W und schreibt den Status(TWSR) ins temp
		cpi		temp, MT_SLA_W_ACK
		Brne	PWM_CNT_WR_ERR
										
PWM_CNT_WR_loop:
		tst		temp3							// 
		Breq	PWM_CNT_WR_END					// 
		ld		temp, Y+						// Lade aus Speicher Daten
		rcall	TWI_MT_Data						// Daten an Slave schreiben
		subi	temp3, 1						// Packetlnge um eins verringern
		cpi		temp, MT_DATA_ACK
		Breq	PWM_CNT_WR_loop					// Wenn die Daten angekommen sind dann, weiterschreiben
		rjmp	PWM_CNT_WR_ERR					// Wenn der Status nicht gleich ACK ist, dann Ende.
	

PWM_CNT_WR_END:									// Gesendete Daten wurden mit ACK quittiert, Packetlge leer, sende Stoppkondition
		rcall	TWI_STOP_CONDITION
		clr		temp
	ret

PWM_CNT_WR_ERR:
		rcall	TWI_MASTER_ERROR				// Return form TWI_Master_Error Error Status Code = TWSR
;Bei einem Fehler den Fehlercode ausgeben
		rcall	sendByte_com					// Transmit Error Code // 
	ret


;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX		
PWM_CNT_RD:						

		rcall	TWI_START_CONDITION
; Statusregister wurde bereits nach temp durch WAIT_TWINT geschrieben
		cpi		temp, MT_Start_Condition
		Brne	PWM_CNT_RD_ERR

; bertrgt die SLA+W
		ldi		temp, PWM_CNT_M16
		rcall	TWI_SLA_W						// Sendet SLA+W und schreibt den Status(TWSR) ins temp
		cpi		temp, MT_SLA_W_ACK
		Brne	PWM_CNT_RD_ERR


		mov		temp, temp4					// CMD- den Befehl versenden

		rcall	TWI_MT_Data
		cpi		temp, MT_DATA_ACK
		Brne	PWM_CNT_RD_ERR
; Ab hier wird der Master in Receiver Modus gesetzt
		rcall	TWI_START_CONDITION
		cpi		temp, MR_Repeated_Start
		Brne	PWM_CNT_RD_ERR

; bertrgt die SLA+R
		ldi		temp,   PWM_CNT_M16				// Sendet SLA+R und schreibt den Status(TWSR) ins temp
		rcall	TWI_SLA_R	
		cpi		temp, MR_SLA_R_ACK	
		Brne	PWM_CNT_RD_ERR
		
		subi	temp3, 1
PWM_CNT_RD_loop:						    	// Ausleseschleife
		cpi		temp3, 1						// Das letzte oder erstletzte zu empfangende Byte wird nicht NACK Quittiert	
		Breq	PWM_CNT_RD_NACK					// Daten Empfangen und mit NACK quittieren
		rcall	TWI_MR_Data						
		st		Y+, temp2						// Empfangenes DatenByte speichern
		dec		temp3							// Packetlnge um eins verringern
		cpi		temp, MR_DATA_ACK				// Daten bertagen, mit ACK- quittieren
		Brne	PWM_CNT_RD_ERR					//
		rjmp	PWM_CNT_RD_loop

PWM_CNT_RD_NACK:
		rcall	TWI_MR_Data_NACK				// Empfange das letzte Byte und sende NACK
		st		Y+, temp2						// Empfangenes DatenByte speichern
		cpi		temp, MR_DATA_NACK				// Daten bertagen, mit NACK- quittieren
		Brne	PWM_CNT_RD_ERR

		rcall	TWI_STOP_CONDITION
		clr		temp
		ret

	
PWM_CNT_RD_ERR:
		rcall	TWI_MASTER_ERROR				// Return form TWI_Master_Error Error Status Code = TWSR
		rcall	sendByte_com					// Transmit Error Code
		ret





;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX		
PWM_CNT_RD_DS:						

		rcall	TWI_START_CONDITION
; Statusregister wurde bereits nach temp durch WAIT_TWINT geschrieben
		cpi		temp, MT_Start_Condition
		Brne	PWM_CNT_RD_DS_ERR

; bertrgt die SLA+W
		ldi		temp, PWM_CNT_M16
		rcall	TWI_SLA_W						// Sendet SLA+W und schreibt den Status(TWSR) ins temp
		cpi		temp, MT_SLA_W_ACK
		Brne	PWM_CNT_RD_DS_ERR


		mov		temp, temp4					// CMD- den Befehl versenden
		rcall	TWI_MT_Data
		cpi		temp, MT_DATA_ACK
		Brne	PWM_CNT_RD_DS_ERR

		mov		temp, High_Byte				// High_Byte Adresse
		rcall	TWI_MT_Data
		cpi		temp, MT_DATA_ACK
		Brne	PWM_CNT_RD_DS_ERR

		mov		temp, Low_Byte				// Low_Byte Adresse
		rcall	TWI_MT_Data
		cpi		temp, MT_DATA_ACK
		Brne	PWM_CNT_RD_DS_ERR

; Ab hier wird der Master in Receiver Modus gesetzt
		rcall	TWI_START_CONDITION
		cpi		temp, MR_Repeated_Start
		Brne	PWM_CNT_RD_DS_ERR

; bertrgt die SLA+R
		ldi		temp,   PWM_CNT_M16				// Sendet SLA+R und schreibt den Status(TWSR) ins temp
		rcall	TWI_SLA_R	
		cpi		temp, MR_SLA_R_ACK	
		Brne	PWM_CNT_RD_DS_ERR
		
		subi	temp3, 3
PWM_CNT_RD_DS_loop:						    	// Ausleseschleife
		cpi		temp3, 1						// Das letzte oder erstletzte zu empfangende Byte wird nicht NACK Quittiert	
		Breq	PWM_CNT_RD_DS_NACK					// Daten Empfangen und mit NACK quittieren
		rcall	TWI_MR_Data						
		st		Y+, temp2						// Empfangenes DatenByte speichern
		dec		temp3							// Packetlnge um eins verringern
		cpi		temp, MR_DATA_ACK				// Daten bertagen, mit ACK- quittieren
		Brne	PWM_CNT_RD_DS_ERR					//
		rjmp	PWM_CNT_RD_DS_loop

PWM_CNT_RD_DS_NACK:
		rcall	TWI_MR_Data_NACK				// Empfange das letzte Byte und sende NACK
		st		Y+, temp2						// Empfangenes DatenByte speichern
		cpi		temp, MR_DATA_NACK				// Daten bertagen, mit NACK- quittieren
		Brne	PWM_CNT_RD_DS_ERR

		rcall	TWI_STOP_CONDITION
		clr		temp
		ret

PWM_CNT_RD_DS_ERR:
		rcall	TWI_MASTER_ERROR				// Return form TWI_Master_Error Error Status Code = TWSR
		rcall	sendByte_com					// Transmit Error Code
		ret

;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
PWM_CNT_WR_DS:						
		rcall	TWI_START_CONDITION
		cpi		temp, MT_Start_Condition
		Brne	PWM_CNT_WR_DS_ERR

; bertrgt die SLA+W
		ldi		temp, PWM_CNT_M16
		rcall	TWI_SLA_W						// Sendet SLA+W und schreibt den Status(TWSR) ins temp
		cpi		temp, MT_SLA_W_ACK
		Brne	PWM_CNT_WR_DS_ERR


		mov		temp, temp4					// CMD- den Befehl versenden
		rcall	TWI_MT_Data
		cpi		temp, MT_DATA_ACK
		Brne	PWM_CNT_RD_DS_ERR

		mov		temp, High_Byte				// High_Byte Adresse
		rcall	TWI_MT_Data
		cpi		temp, MT_DATA_ACK
		Brne	PWM_CNT_RD_DS_ERR

		mov		temp, Low_Byte				// Low_Byte Adresse
		rcall	TWI_MT_Data
		cpi		temp, MT_DATA_ACK
		Brne	PWM_CNT_RD_DS_ERR
			
		subi	temp3, 3											
PWM_CNT_WR_DS_loop:
		tst		temp3							// 
		Breq	PWM_CNT_WR_DS_END				// 
		ld		temp, Y+						// Lade aus Speicher Daten
		rcall	TWI_MT_Data						// Daten an Slave schreiben
		subi	temp3, 1						// Packetlnge um eins verringern
		cpi		temp, MT_DATA_ACK
		Breq	PWM_CNT_WR_DS_loop				// Wenn die Daten angekommen sind dann, weiterschreiben
		rjmp	PWM_CNT_WR_DS_ERR				// Wenn der Status nicht gleich ACK ist, dann Ende.
	

PWM_CNT_WR_DS_END:								// Gesendete Daten wurden mit ACK quittiert, Packetlge leer, sende Stoppkondition
		rcall	TWI_STOP_CONDITION
		clr		temp
	ret

PWM_CNT_WR_DS_ERR:
		rcall	TWI_MASTER_ERROR				// Return form TWI_Master_Error Error Status Code = TWSR
;Bei einem Fehler den Fehlercode ausgeben
		rcall	sendByte_com					// Transmit Error Code // 
	ret



.exit

