;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;X																			  X
;X 	Crated by dotstyler
;X 	End Date: 22.02.2009
;X 	Firmware vers.: 3.4



.include "m16def.inc"

.device Atmega16




; Register definitionen_____________
; Hier werden den "General Purpose Working Register" Namen vergeben 

		.def	temp		=r16			//  Bit 1-8			|	32- Bit Akku
		.def    temp2		=r17			//  Bit 9-16		|	32- Bit Akku
		.def	temp3		=r18			//  Bit 17-24		|	32- Bit Akku
		.def	temp4		=r19			//  Bit 25-32		|	32- Bit Akku		
		.def	temp5		=r20
		.def	temp6		=r21

		.def	BS_Reg 		=r22    		//  Buffer Status Register
;							=r23			//  FREE
		.def	High_Byte   =r25			//  Doppelregister r24, r25   | Bestimmt fr allgemeine 16- Bit operationen
		.def	Low_Byte	=r24			//  Doppelregister r24, r25	 | Bestimmt fr allgemeine 16- Bit operationen
;							=r25			//	FREE
;			X- Pointer		=r26			//	X- Pointer Low Byte	
;			X- Pointer		=r27			//	X- Pointer High Byte
;			Y- Pointer		=r28			//	Y- Pointer Low Byte
;			Y- Pointer		=r29			//	Y- Pointer High Byte
;			Z- Pointer		=r30			//	Z- Pointer Low Byte
;			Z- Pointer		=r31			//	Z- Pointer High Byte
		

;							=r0				//  Multiply Result (Low Byte)
;							=r1				//  Multiply Result (High Byte)
		.def	Faktor_LB	=r2
		.def	Faktor_HB	=r3
		.def    z0        	=r4             //  Zahl fr Integer -> ASCII Umwandlung
		.def    z1        	=r5
		.def    z2        	=r6
		.def    z3        	=r7

; and so on...



		.equ	SRAM_Begin	=$60
		.equ	temp_conv_space =$60

; IRQ____Address_____Routine______________
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
.org	$000
	jmp 	RESET 			; Reset Handler
	reti;jmp EXT_INT0		; IRQ0 Handler
	reti;jmp EXT_INT1		; IRQ1 Handler
	reti;jmp TIM2_COMP		; Timer2 Compare Handler
	reti;jmp TIM2_OVF	 	; Timer2 Overflow Handler
	reti;jmp TIM1_CAPT 		; Timer1 Capture Handler
	reti;.org	$00C
;	jmp 	TIM1_COMPA 		; Timer1 CompareA Handler
	reti;jmp TIM1_COMPB 	; Timer1 CompareB Handler
	reti;jmp TIM1_OVF 		; Timer1 Overflow Handler
	reti;jmp TIM0_OVF 		; Timer0 Overflow Handler
	reti;jmp SPI_STC 		; SPI Transfer Complete Handler
	reti;.org	$016
;	jmp 	USART_RXC 		; USART RX Complete Handler 
	reti;jmp USART_UDRE 	; UDR Empty Handler
	reti;jmp USART_TXC 		; USART TX Complete Handler
	reti;jmp ADC_Complete 	; ADC Conversion Complete Handler
	reti;jmp EE_RDY 		; EEPROM Ready Handler
	reti;jmp ANA_COMP 		; Analog Comparator Handler
;.org	$022
;	jmp TWSI 				; Two-wire Serial Interface Handler
	reti;jmp EXT_INT2 		; IRQ2 Handler
	reti;jmp TIM0_COMP 		; Timer0 Compare Handler
	reti;jmp SPM_RDY 		; Store Program Memory Ready Handler

;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX




;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;X        INCLUDE FILES		  X
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXX


.include "TWI_Master_Routines.asm"
.include "PWMCNT_LIB.asm"
.include "CMD_DEC_Master.asm"



RESET:					; Reset Handler



;			*******************************
;			*  Watchdog  Initialisierung  *
;			*******************************
;		ldi		temp, (X<<WDTOE)|(X<<WDE)|(X<<WDP2)|(X<<WDP1)|(X<<WDP0) 	// Comment
;		out		WDTCR, temp

;			*******************************
;			*   	Stack pointer 		  *
;			*******************************

		ldi		temp, high(RAMEND)
		out     SPH, temp
 		ldi		temp, Low(RAMEND)
		out		SPL, temp

;			*********************************
;			*   I/O =Input/Output  define   *
;			*********************************
; Hier wird Datenrichtung festgelegt ob die I/O's Pullup, Threestate, Output, Input oder I/O sein werden(sollten).
; 	Port A
; 	Port B
; 	Port C
; Port A = INPUT
		clr		temp
		out		DDRA, temp
		out		PortA, temp


			;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
			;X 			USART_ Initialisierung			X
			;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
; Ein bisschen Mathe fr die Rechenfaulen

		.equ 	CLOCK	 = 3686400		;11059200		; 7372800 
		.equ 	BAUD  	 = 19200	    ; Gewnschte Baudrate
		.equ 	UBRRVAL  = CLOCK/(BAUD*16)-1


; Set baud rate   
		ldi		temp, 0<<URSEL 			; Whle ber URSEL das Baudratenregister aus.
		out		UBRRH, temp
	 
		ldi		temp, LOW(UBRRVAL)
		out 	UBRRL, temp
		ldi     temp, HIGH(UBRRVAL)
		out 	UBRRH, temp

;USART Register fest Konfigurieren
		ldi		temp, (0<<RXC)|(0<<TXC)|(0<<UDRE)|(0<<FE)|(0<<DOR)|(0<<PE)|(0<<U2X)|(0<<MPCM)
		out		UCSRA, temp

		ldi		temp, (0<<RXCIE)|(0<<TXCIE)|(0<<UDRIE)|(1<<RXEN)|(1<<TXEN)|(0<<UCSZ2)|(0<<RXB8)|(0<<TXB8)
		out		UCSRB, temp

		ldi		temp, (1<<URSEL)|(0<<UMSEL)|(1<<UPM1)|(0<<UPM0)|(0<<USBS)|(1<<UCSZ1)|(1<<UCSZ0)|(0<<UCPOL)
		out		UCSRC, temp

;   Einzelheiten zur USART Konfiguration
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;	Frame Format
;	8- Bit
;	1- Stopbit
;	Even Parity (Gerade Paritt)
;	Baudrate=  19200 Baud
;	Transmitt enable
;	Receive enable


			;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
			;X 			TWI- Initialisierung			X
			;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
		.equ	TWBR_val		= 32
		.equ	TWI_Prescaler	= 1				// 1= Clock divided by 4
		
		rcall	TWI_MASTER_INIT


	



Programm:



PortA_abfrage:
		in		temp, PinA
		com		temp

		cpi		temp, 128
		Breq	SWITCH_7_press

		cpi		temp, 64
		Breq	SWITCH_6_press

		cpi		temp, 32
		Breq	SWITCH_5_press

		cpi		temp, 16
		Breq	SWITCH_4_press

		cpi		temp, 8
		Breq	SWITCH_3_press

		cpi		temp, 4
		Breq	SWITCH_2_press

		cpi		temp, 2
		Breq	SWITCH_1_press

		cpi		temp, 1
		Breq	SWITCH_0_press
; Keine Taste wurde gedrckt oder mehrere tasten wurden zugleich gedrckt
; was nicht gestattet ist. :-p
		rjmp	Programm

Taste_gedrueckt:
		in		temp, PinA
		com		temp
		tst		temp
		Brne	Taste_gedrueckt
		ret

SWITCH_7_press:
		rcall	Taste_gedrueckt
		rcall	SW7_prog
		rjmp	Programm
;*************************************************
SWITCH_6_press:
		rcall	Taste_gedrueckt
		rcall	SW6_prog
		rjmp	Programm
;*************************************************
SWITCH_5_press:
		rcall	Taste_gedrueckt
		rcall	SW5_prog
		rcall	Delay
		rjmp	Programm
;*************************************************
SWITCH_4_press:
		rcall	Taste_gedrueckt
		rcall	SW4_Prog
		rjmp	Programm

SWITCH_3_press:
		rcall	Taste_gedrueckt
		rcall	SW3_Prog
		rjmp	Programm

SWITCH_2_press:
		rcall	Taste_gedrueckt
		rcall   SW2_prog

		rjmp	Programm

SWITCH_1_press:
		rcall	Taste_gedrueckt
		rcall	SW_1_Prog

		rjmp	Programm

SWITCH_0_press:
		rcall	Taste_gedrueckt
		rcall	SW_0_Prog	

		rjmp	Programm





	





Delay:
Push	temp
Push	temp2
Push	temp3



DElay_init:
ldi		temp,00
ldi		temp2, 1
ldi		temp3, 1
Delay_main:
dec		temp
brne	Delay_main	
dec		temp2
brne	Delay_main
dec		temp3
brne	Delay_main




Pop		temp3
Pop		temp2
Pop		temp

ret












sendbyte_com:   							  			// bertrage Daten ber USART
        sbis 	UCSRA, UDRE                  		; warten bis das UART bereit ist
        rjmp 	sendbyte_com
        out 	UDR, temp
        ret


Terminal_Command:
       ldi 		temp, 10     	                  	; ASCII "LF" Line Feed, New Line 
       rcall 	sendbyte_com                    	; (Zeilenumbruch im Terminal)
       ldi 		temp, 13							; ASCII "CR" Carriage Return	
       rcall 	sendbyte_com
	   ret
.exit
